package com.gwssi.common.tax.utils;

import com.gwssi.common.util.SpringUtil;
import com.gwssi.pdf.api.LicenseDownloadApi;
import com.squareup.okhttp.*;
import dm.jdbc.log.LogFactory;
import org.apache.commons.httpclient.Header;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.util.EntityUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.StringUtils;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2017/11/17.
 */
public class HttpClientUtil {
    private static final Logger LOG = LoggerFactory.getLogger(HttpClientUtil.class);
    /**
     * Content-Type为application/x-www-form-urlencoded
     * @param url
     * @return
     */
    public static   Map<String,Object> doPost(String url ,Map<String,Object> param,String message ){
        Map<String,Object>result=new HashMap<>();
        LOG.info("url:{},param:{}",url,param);
        try {
            OkHttpClient client = new OkHttpClient();
            StringBuffer sbf=new StringBuffer();
            for(Map.Entry<String,Object> data :param.entrySet()){
                String key = data.getKey();
                Object value = data.getValue();
                sbf.append(key);
                sbf.append("=");
                sbf.append(value);
                sbf.append("&");
            }
            String params = sbf.substring(0, sbf.length() - 1);
            MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded");
            RequestBody body = RequestBody.create(mediaType, params);
            Request request = new Request.Builder()
                    .url(url)
                    .method("POST", body)
                    .addHeader("Content-Type", "application/x-www-form-urlencoded")
                    .build();
            Response response = client.newCall(request).execute();
            int code = response.code();
            if(200==code){
                String stringRes = response.body().string();
                result.put("result",stringRes);
                result.put("state",1);
            }else{
                result.put("result","");
                result.put("state",0);
            }
        }catch(IOException e){
            new RuntimeException(message+"异常");
        }
        return result;
    }

    public static Map<String, Object> bodyPost(String url,String param,String message){
        LOG.info("说明：{}，参数：{},url:{}",message,param,url);
        OkHttpClient client = new OkHttpClient();
        Map<String,Object>result=new HashMap<>();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, param);
        Request request = new Request.Builder()
                .url(url)
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .build();
        try {
            Response response = client.newCall(request).execute();
            int code = response.code();
            if(200==code){
                String stringRes = response.body().string();
                result.put("result",stringRes);
                result.put("state",1);
            }else{
                result.put("result","");
                result.put("state",0);
            }
        } catch (IOException e) {
            new RuntimeException(message+"异常");
        }
        return result;
    }

    public static String doGet(String url, Map<String, String> params) throws Exception {
         CloseableHttpClient httpClient = (CloseableHttpClient) SpringUtil.getBean("httpClient");
         RequestConfig requestConfig = (RequestConfig) SpringUtil.getBean("requestConfig");
        if(params!=null){
            URIBuilder builder = new URIBuilder(url);
            for (Map.Entry<String, String> entry : params.entrySet()) {
                builder.setParameter(entry.getKey(), entry.getValue());
            }
            url = builder.build().toString();
        }
        HttpGet httpGet = new HttpGet(url);
        httpGet.setConfig(requestConfig);
        CloseableHttpResponse response = null;
        try {
            // 执行请求
            response = httpClient.execute(httpGet);
            // 判断返回状态是否为200
            if (response.getStatusLine().getStatusCode() == 200) {
                return EntityUtils.toString(response.getEntity(), "UTF-8");
            } else {
                throw new RuntimeException("内部服务接口调用异常，请联系管理员");
            }
        } finally {
            if (response != null) {
                response.close();
            }
        }
    }

}

